--[[
	ȨУؾ
	ãɺ
	li_haitao create
--]]
print("Load XmlParser")

--[[ӿparseXml
	
	xmlValueΪ
	tableʽ
	buf=
	<?xml version="1.0" encoding="GB2312" ?>
	<Notify>
    <CmdType>Keepalive</CmdType>
    <SN>15</SN>
    <DeviceID>34020000001110000001</DeviceID>
    <Status>OK</Status>
	</Notify>
	
	xmlValueΪ
	xmlValue["Notify"]["CmdType"]["@Data"]="Keepalive"
	xmlValue["Notify"]["SN"]["@Data"]="15"
	xmlValue["Notify"]["DeviceID"]["@Data"]="34020000001110000001"
	xmlValue["Notify"]["Status"]["@Data"]="OK"
	
--]]
function parseXml(buf, xmlValue)
	if type(buf) ~= "string" then return false end
	body = string.gsub(buf, "%<%?(.-)%?%>", "")
	body = standerd(body)
	parseBody(body, xmlValue)
end


function hasNode(buf)
	return string.match(buf, "<(%w+)(.-)>")
end

function getPatten(origin)
	if origin then
		return string.gsub(origin, "([%%%.%-%*%+%?%(%)%[%]])", "%%%1")
	end
end

function printXmlValue(xmlValue, dir)
	for key in pairs(xmlValue) do
		local dir = dir..'['..key..']'
		if type(xmlValue[key]) == "table" then
			printXmlValue(xmlValue[key], dir)
		else
			if key ~= "@name" then
				print(dir..'='..xmlValue[key])
			end
		end
	end
end

function getTag(s, xmlValue)
	local tag = string.match(s, "<([%w%_]+)[%W]*")
	
	local e = string.find(s, "=")
	local last = 1
	if not e then
		return tag
	end 
	if type(xmlValue[tag]) ~= "table" then
		xmlValue[tag]={}
		xmlValue[tag]["@Attr"] = {}
	end
	
	while e do
		local key,value = string.match(s, '[%W]*([%w%_]+)[%W]*=[%W]*"(.-)"[%W]*', last)
		--print("key=value "..key.."="..value)
		xmlValue[tag]["@Attr"][key]=value
		last = e
		e = string.find(s, "=", e + 1)
	end
	return tag
end

function parseBody(buf, xmlValue)

	local bRet = true
	local iEnd = 1
	while iEnd do 
		iStart,iEnd,key=string.find(buf,'<(.-)>')	
		if key then
			keypatten = getPatten(key)
			
			tag = getTag("<"..key..">", xmlValue)
			
			tagpatten = getPatten(tag)

			value = string.match(buf, "<"..keypatten..">(.-)</"..tagpatten..">")
			valuepatten = getPatten(value)
			buf = string.gsub(buf, "<"..keypatten..">"..valuepatten.."</"..tagpatten..">", "", 1)
				
			if hasNode(value) then

				if type(xmlValue[tag]) == "table" then
					if not xmlValue[tag]["@Attr"] then
						
						if not xmlValue[tag][1] then -- ǰһͬ,Ҫ飬1ʼ
							local temp = xmlValue[tag]
							xmlValue[tag] = {}
							xmlValue[tag][1] = temp
						end		
					end
				else
					xmlValue[tag] = {}
				end
				

				--жǷΪ飬飬ΪԭС+1
				a = xmlValue[tag]
				if a[1]	then
					a[#a+1] = {}
					parseBody(value, a[#a])
				else
					parseBody(value, a)
				end
				
			else
				if type(xmlValue[tag]) ~= "table" then
					xmlValue[tag] = {}
				end
				
				if xmlValue[tag]["@Data"] then --ǰһͬ,Ҫ飬1ʼ
					local temp = xmlValue[tag]
					xmlValue[tag] = {}
					xmlValue[tag][1] = temp
				end
				
				b = xmlValue[tag]
				if b and b[1] then
					b[#b+1] = {}
					b[#b]["@Data"] = value
				else
					b["@Data"] = value
				end
				
			end
		end
	end
	return bRet
end

function standerd(xml)
	
	e = string.find(xml, "/>")
	while e do 
		xml = string.gsub(xml, '<([%w%-]+)(%C-)/>', "<%1%2></%1>")
		e = string.find(xml, "/>")
	end
	--print(xml)
	return xml
end



--Ϊʹ

--[==[

r = 
[[
<?xml version="1.0" encoding="GB2312" ?>
<Response>
    <CmdType>DeviceStatus</CmdType>
    <SN>248</SN>
    <DeviceID>34020000001110000001</DeviceID>
    <Result>OK</Result>
    <Online>ONLINE</Online>
    <Status>OK</Status>
    <DeviceTime>2013-07-15T10:57:43</DeviceTime>
    <Encode>ON</Encode>
    <Record>OFF</Record>
	<Test name="TEST"/>
    <Alarmstatus Num="4" Num="Hello">
        <Item>
            <DeviceID>34020000001340000001</DeviceID>
            <DutyStatus>ONDUTY</DutyStatus>
        </Item>
        <Item>
            <DeviceID>34020000001340000002</DeviceID>
            <DutyStatus>ONDUTY</DutyStatus>
        </Item>
        <Item>
            <DeviceID>34020000001340000003</DeviceID>
            <DutyStatus>ONDUTY</DutyStatus>
        </Item>
        <Item>
            <DeviceID>34020000001340000004</DeviceID>
            <DutyStatus>ONDUTY</DutyStatus>
        </Item>
    </Alarmstatus>
</Response>
]]

local xml = {}
local dir = ""
parseXml(r, xml)
printXmlValue(xml, dir)
--]==]








